<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendDiaSemanaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function findConsolidado($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':NRORG' => $NRORG,
            ':CDLOJA' => $CDLOJA,
            ':TCDLOJA' => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO, $params);
    }
    
    public function findAnalitico($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL' => $CDFILIAL,
            ':NRORG' => $NRORG,
            ':CDLOJA' => $CDLOJA,
            ':TCDLOJA' => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO, $params);
    }

    const GET_VENDA_DIA_CONSOLIDADO = "
      SELECT 'TODAS' AS LABELFILIAL, FILOCAVE.DIASEMANA, COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
             SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
             ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
             ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
             FILOCAVE.NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES
        FROM ITEMVENDA I
        JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                    FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA,1)) OVER (PARTITION BY FILOCA.NRORG, TO_CHAR(V.DTENTRVENDA,'D')) AS NRPESMESAVENDA
                FROM VENDA V
                JOIN ( SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                     FROM CAIXA C
                     JOIN ( SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                        FROM LOJA L
                        JOIN ( SELECT F.CDFILIAL, F.NRORG
                            FROM FILIAL F
                            WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                              AND F.NRORG = :NRORG ) FI
                          ON L.CDFILIAL = FI.CDFILIAL
                         AND L.NRORG = FI.NRORG 
                         WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))) FILO
                     ON C.CDFILIAL = FILO.CDFILIAL
                    AND C.CDLOJA = FILO.CDLOJA
                    AND C.NRORG = FILO.NRORG) FILOCA
                 ON V.CDCAIXA = FILOCA.CDCAIXA
                AND V.CDLOJA = FILOCA.CDLOJA
                AND V.CDFILIAL = FILOCA.CDFILIAL
                AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O'
                AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN) FILOCAVE
          ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
         AND I.CDFILIAL = FILOCAVE.CDFILIAL
         AND I.CDCAIXA = FILOCAVE.CDCAIXA
         AND I.NRORG = FILOCAVE.NRORG
       GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.NRPESMESAVENDA, :DTVENDAINI, :DTVENDAFIN
       ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";

    const GET_VENDA_DIA_ANALITICO = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DIASEMANA, COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
             SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
             ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
             ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
             FILOCAVE.NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES
        FROM ITEMVENDA I
        JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                    FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA,1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D')) AS NRPESMESAVENDA
                FROM VENDA V
                JOIN ( SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                     FROM CAIXA C
                     JOIN ( SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                        FROM LOJA L
                        JOIN ( SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                            FROM FILIAL F
                            WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                              AND F.NRORG = :NRORG ) FI
                          ON L.CDFILIAL = FI.CDFILIAL
                         AND L.NRORG = FI.NRORG 
                         WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))) FILO
                     ON C.CDFILIAL = FILO.CDFILIAL
                    AND C.CDLOJA = FILO.CDLOJA
                    AND C.NRORG = FILO.NRORG) FILOCA
                 ON V.CDCAIXA = FILOCA.CDCAIXA
                AND V.CDLOJA = FILOCA.CDLOJA
                AND V.CDFILIAL = FILOCA.CDFILIAL
                AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O'
                AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN) FILOCAVE
          ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
         AND I.CDFILIAL = FILOCAVE.CDFILIAL
         AND I.CDCAIXA = FILOCAVE.CDCAIXA
         AND I.NRORG = FILOCAVE.NRORG
       GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRPESMESAVENDA, :DTVENDAINI, :DTVENDAFIN
       ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
}